Rare
 0/13

Slope Trick

Author: Benjamin Qi

Slope trick refers to a way to manipulate piecewise linear convex functions. Includes a simple solution to USACO Landscaping.

Tutorials

Resources
CF3 problems using this trick
CFclarifying the above and another example problem

From the latter link (modified):

Slope trick is a way to represent a function that satisfies the following conditions:

  • It can be divided into multiple sections, where each section is a linear function (usually) with an integer slope.
  • It is a convex/concave function. In other words, the slope of each section is non-decreasing or non-increasing when scanning the function from left to right.

It's generally applicable as a DP optimization.

Pro Tip

Usually you can come up with a slower (usually ) DP first and then optimize it to with slope trick.

The rest of this module assumes that you know the basic idea of this trick. In particular, you should be at least somewhat familiar with the time solution to the first problem in zscoder's tutorial:

StatusSourceProblem NameDifficultyTagsSolutionURL
CFEasy
Show Tags

Slope Trick

Check CF

It's ok if you found the explanations confusing; the example below should help clarify.

Buy Low Sell High

StatusSourceProblem NameDifficultyTagsSolutionURL
CFEasy
Show Tags

Slope Trick

Slow Solution

Let denote the maximum amount of money you can have on day if you have exactly shares of stock on that day. The final answer will be . This solution runs in time.

Slow Code

If we run this on the first sample case, then we get the following table:

Input:

9
10 5 4 7 9 12 6 2 10

Output:

dp[0] = {  0}
dp[1] = {  0, -10}
dp[2] = {  0,  -5, -15}
dp[3] = {  0,  -4,  -9, -19}
dp[4] = {  3,  -2,  -9, -16, -26}
dp[5] = {  7,   0,  -7, -16, -25, -35}
dp[6] = { 12,   5,  -4, -13, -23, -35, -47}
dp[7] = { 12,   6,  -1, -10, -19, -29, -41, -53}
dp[8] = { 12,  10,   4,  -3, -12, -21, -31, -43, -55}
dp[9] = { 20,  14,   7,  -2, -11, -21, -31, -41, -53, -65}

However, the DP values look quite special! Specifically, let

Then for all . In other words, as a function of is concave down.

Full Solution

Explanation

My Code

Extension

Stock Trading (USACO Camp): What if your amount of shares can go negative, but you can never have more than shares or less than ?

Potatoes & Fertilizers

StatusSourceProblem NameDifficultyTagsSolutionURL
LMiONormal
Show Tags

Slope Trick

Simplifying the Problem

Instead of saying that moving fertilizer from segment to segment costs , we'll say that it costs to move fertilizer from a segment to an adjacent segment.

Let the values of after all the transfers be . If we know this final sequence, how much did the transfers cost (in the best case scenario)? It turns out that this is just

We can show that this is a lower bound and that it's attainable. The term denotes the number of units of fertilizer that move from segment to segment . Namely, if is positive then units of fertilizer moved from segment to segment ; otherwise, units of fertilizer moved in the opposite direction. Note that it is never optimal to have fertilizer moving in both directions.

Let and define for each . Similarly, define and . Since we want for all , we should have Conversely, every sequence that satisfies this property corresponds to a valid way to assign values of .

Now you can verify that . This makes sense since moving one unit of fertilizer one position is equivalent to changing one of the by one (although always remain the same).

Slow Solution

For each and , let be the minimum cost to determine such that . Note that by definition, . We can easily calculate these values in time.

Full Solution

Explanation

My Code

USACO Landscaping

StatusSourceProblem NameDifficultyTagsSolutionURL
PlatHard
Show Tags

Slope Trick

External Sol

This looks similar to the previous task (we're moving dirt instead of fertilizer), so it's not too hard to guess that slope trick is applicable.

Slow Solution

Let equal the number of ways to move dirt around the first flowerbeds such that the first flowerbeds all have the correct amount of dirt while the -th flowerbed has extra units of dirt (or lacks units of dirt if is negative). The answer will be .

Full Solution

Explanation

My Solution

Extension

We can solve this problem when is not so small by maintaining a map from to for all such that the latter quantity is nonzero. Then the operation "add to for all " corresponds to a point update in the map (advance() in the code below).

Code (from Alex Wei)

Problems

Although we haven't provided any examples of this, some of the problems below will require you to merge two slope containers (usually priority queues).

StatusSourceProblem NameDifficultyTagsSolutionURL
CFNormal
Show Tags

Slope Trick

Check CF
CCNormal
Show Tags

Slope Trick

Check CC
CEOINormal
Show Tags

Slope Trick

View Solution
NOI.sgHard
Show Tags

Slope Trick

View Solution
CFHard
Show Tags

Slope Trick

Check CF
CFHard
Show Tags

Slope Trick

Check CF
APIOHard
Show Tags

Slope Trick, Small to Large

View Solution
CFVery Hard
Show Tags

Slope Trick

Check CF
ICPC WFVery Hard
Show Tags

Slope Trick, Small to Large

Show Sketch

Module Progress:

Join the USACO Forum!

Stuck on a problem, or don't understand a module? Join the USACO Forum and get help from other competitive programmers!

Give Us Feedback on Slope Trick!